"use strict";

var parser = require("cirru-parser"),
    Immutable = require("immutable");

var syntax = require("./syntax");

var bind = function bind(v, k) {
  return k(v);
};

var initialState = Immutable.fromJS({
  indentation: "",
  code: "",
  types: {}
});

var writeProgram = function writeProgram(state, tree) {
  var result = tree.reduce(function (acc, exp) {
    return bind(syntax.write(acc.update("code", function (code) {
      return code + "\n";
    }), exp), function (newState) {
      return newState.update("code", function (code) {
        return code + "\n";
      });
    });
  }, state);
  return result.get("code");
};

exports.transform = function (source) {
  var ast = parser.pare(source, "runtime");
  return writeProgram(initialState, Immutable.fromJS(ast));
};